// *** WARNING: this file was generated by test. ***
// *** Do not edit by hand unless you're certain you know what you are doing! ***

package com.pulumi.kubernetes;

import com.pulumi.core.Output;
import com.pulumi.core.annotations.Import;
import com.pulumi.core.internal.Codegen;
import com.pulumi.kubernetes.inputs.KubeClientSettingsArgs;
import java.lang.String;
import java.util.Objects;
import java.util.Optional;
import javax.annotation.Nullable;


public final class ProviderArgs extends com.pulumi.resources.ResourceArgs {

    public static final ProviderArgs Empty = new ProviderArgs();

    /**
     * If present, the name of the kubeconfig cluster to use.
     * 
     */
    @Import(name="cluster")
    private @Nullable Output<String> cluster;

    /**
     * @return If present, the name of the kubeconfig cluster to use.
     * 
     */
    public Optional<Output<String>> cluster() {
        return Optional.ofNullable(this.cluster);
    }

    /**
     * If present, the name of the kubeconfig context to use.
     * 
     */
    @Import(name="context")
    private @Nullable Output<String> context;

    /**
     * @return If present, the name of the kubeconfig context to use.
     * 
     */
    public Optional<Output<String>> context() {
        return Optional.ofNullable(this.context);
    }

    /**
     * Options for tuning the Kubernetes client used by a Provider.
     * 
     */
    @Import(name="kubeClientSettings", json=true)
    private @Nullable Output<KubeClientSettingsArgs> kubeClientSettings;

    /**
     * @return Options for tuning the Kubernetes client used by a Provider.
     * 
     */
    public Optional<Output<KubeClientSettingsArgs>> kubeClientSettings() {
        return Optional.ofNullable(this.kubeClientSettings);
    }

    /**
     * The contents of a kubeconfig file or the path to a kubeconfig file.
     * 
     */
    @Import(name="kubeconfig")
    private @Nullable Output<String> kubeconfig;

    /**
     * @return The contents of a kubeconfig file or the path to a kubeconfig file.
     * 
     */
    public Optional<Output<String>> kubeconfig() {
        return Optional.ofNullable(this.kubeconfig);
    }

    private ProviderArgs() {}

    private ProviderArgs(ProviderArgs $) {
        this.cluster = $.cluster;
        this.context = $.context;
        this.kubeClientSettings = $.kubeClientSettings;
        this.kubeconfig = $.kubeconfig;
    }

    public static Builder builder() {
        return new Builder();
    }
    public static Builder builder(ProviderArgs defaults) {
        return new Builder(defaults);
    }

    public static final class Builder {
        private ProviderArgs $;

        public Builder() {
            $ = new ProviderArgs();
        }

        public Builder(ProviderArgs defaults) {
            $ = new ProviderArgs(Objects.requireNonNull(defaults));
        }

        /**
         * @param cluster If present, the name of the kubeconfig cluster to use.
         * 
         * @return builder
         * 
         */
        public Builder cluster(@Nullable Output<String> cluster) {
            $.cluster = cluster;
            return this;
        }

        /**
         * @param cluster If present, the name of the kubeconfig cluster to use.
         * 
         * @return builder
         * 
         */
        public Builder cluster(String cluster) {
            return cluster(Output.of(cluster));
        }

        /**
         * @param context If present, the name of the kubeconfig context to use.
         * 
         * @return builder
         * 
         */
        public Builder context(@Nullable Output<String> context) {
            $.context = context;
            return this;
        }

        /**
         * @param context If present, the name of the kubeconfig context to use.
         * 
         * @return builder
         * 
         */
        public Builder context(String context) {
            return context(Output.of(context));
        }

        /**
         * @param kubeClientSettings Options for tuning the Kubernetes client used by a Provider.
         * 
         * @return builder
         * 
         */
        public Builder kubeClientSettings(@Nullable Output<KubeClientSettingsArgs> kubeClientSettings) {
            $.kubeClientSettings = kubeClientSettings;
            return this;
        }

        /**
         * @param kubeClientSettings Options for tuning the Kubernetes client used by a Provider.
         * 
         * @return builder
         * 
         */
        public Builder kubeClientSettings(KubeClientSettingsArgs kubeClientSettings) {
            return kubeClientSettings(Output.of(kubeClientSettings));
        }

        /**
         * @param kubeconfig The contents of a kubeconfig file or the path to a kubeconfig file.
         * 
         * @return builder
         * 
         */
        public Builder kubeconfig(@Nullable Output<String> kubeconfig) {
            $.kubeconfig = kubeconfig;
            return this;
        }

        /**
         * @param kubeconfig The contents of a kubeconfig file or the path to a kubeconfig file.
         * 
         * @return builder
         * 
         */
        public Builder kubeconfig(String kubeconfig) {
            return kubeconfig(Output.of(kubeconfig));
        }

        public ProviderArgs build() {
            $.kubeconfig = Codegen.stringProp("kubeconfig").output().arg($.kubeconfig).env("KUBECONFIG").getNullable();
            return $;
        }
    }

}
