// *** WARNING: this file was generated by test. ***
// *** Do not edit by hand unless you're certain you know what you are doing! ***

package com.pulumi.myedgeorder.inputs;

import com.pulumi.core.Output;
import com.pulumi.core.annotations.Import;
import com.pulumi.myedgeorder.inputs.CustomerSubscriptionDetailsArgs;
import com.pulumi.myedgeorder.inputs.FilterablePropertyArgs;
import java.lang.String;
import java.util.List;
import java.util.Map;
import java.util.Objects;
import java.util.Optional;
import javax.annotation.Nullable;


public final class ListProductFamiliesArgs extends com.pulumi.resources.InvokeArgs {

    public static final ListProductFamiliesArgs Empty = new ListProductFamiliesArgs();

    /**
     * Customer subscription properties. Clients can display available products to unregistered customers by explicitly passing subscription details
     * 
     */
    @Import(name="customerSubscriptionDetails")
    private @Nullable Output<CustomerSubscriptionDetailsArgs> customerSubscriptionDetails;

    /**
     * @return Customer subscription properties. Clients can display available products to unregistered customers by explicitly passing subscription details
     * 
     */
    public Optional<Output<CustomerSubscriptionDetailsArgs>> customerSubscriptionDetails() {
        return Optional.ofNullable(this.customerSubscriptionDetails);
    }

    /**
     * $expand is supported on configurations parameter for product, which provides details on the configurations for the product.
     * 
     */
    @Import(name="expand")
    private @Nullable Output<String> expand;

    /**
     * @return $expand is supported on configurations parameter for product, which provides details on the configurations for the product.
     * 
     */
    public Optional<Output<String>> expand() {
        return Optional.ofNullable(this.expand);
    }

    /**
     * Dictionary of filterable properties on product family.
     * 
     */
    @Import(name="filterableProperties", required=true)
    private Output<Map<String,List<FilterablePropertyArgs>>> filterableProperties;

    /**
     * @return Dictionary of filterable properties on product family.
     * 
     */
    public Output<Map<String,List<FilterablePropertyArgs>>> filterableProperties() {
        return this.filterableProperties;
    }

    /**
     * $skipToken is supported on list of product families, which provides the next page in the list of product families.
     * 
     */
    @Import(name="skipToken")
    private @Nullable Output<String> skipToken;

    /**
     * @return $skipToken is supported on list of product families, which provides the next page in the list of product families.
     * 
     */
    public Optional<Output<String>> skipToken() {
        return Optional.ofNullable(this.skipToken);
    }

    private ListProductFamiliesArgs() {}

    private ListProductFamiliesArgs(ListProductFamiliesArgs $) {
        this.customerSubscriptionDetails = $.customerSubscriptionDetails;
        this.expand = $.expand;
        this.filterableProperties = $.filterableProperties;
        this.skipToken = $.skipToken;
    }

    public static Builder builder() {
        return new Builder();
    }
    public static Builder builder(ListProductFamiliesArgs defaults) {
        return new Builder(defaults);
    }

    public static final class Builder {
        private ListProductFamiliesArgs $;

        public Builder() {
            $ = new ListProductFamiliesArgs();
        }

        public Builder(ListProductFamiliesArgs defaults) {
            $ = new ListProductFamiliesArgs(Objects.requireNonNull(defaults));
        }

        /**
         * @param customerSubscriptionDetails Customer subscription properties. Clients can display available products to unregistered customers by explicitly passing subscription details
         * 
         * @return builder
         * 
         */
        public Builder customerSubscriptionDetails(@Nullable Output<CustomerSubscriptionDetailsArgs> customerSubscriptionDetails) {
            $.customerSubscriptionDetails = customerSubscriptionDetails;
            return this;
        }

        /**
         * @param customerSubscriptionDetails Customer subscription properties. Clients can display available products to unregistered customers by explicitly passing subscription details
         * 
         * @return builder
         * 
         */
        public Builder customerSubscriptionDetails(CustomerSubscriptionDetailsArgs customerSubscriptionDetails) {
            return customerSubscriptionDetails(Output.of(customerSubscriptionDetails));
        }

        /**
         * @param expand $expand is supported on configurations parameter for product, which provides details on the configurations for the product.
         * 
         * @return builder
         * 
         */
        public Builder expand(@Nullable Output<String> expand) {
            $.expand = expand;
            return this;
        }

        /**
         * @param expand $expand is supported on configurations parameter for product, which provides details on the configurations for the product.
         * 
         * @return builder
         * 
         */
        public Builder expand(String expand) {
            return expand(Output.of(expand));
        }

        /**
         * @param filterableProperties Dictionary of filterable properties on product family.
         * 
         * @return builder
         * 
         */
        public Builder filterableProperties(Output<Map<String,List<FilterablePropertyArgs>>> filterableProperties) {
            $.filterableProperties = filterableProperties;
            return this;
        }

        /**
         * @param filterableProperties Dictionary of filterable properties on product family.
         * 
         * @return builder
         * 
         */
        public Builder filterableProperties(Map<String,List<FilterablePropertyArgs>> filterableProperties) {
            return filterableProperties(Output.of(filterableProperties));
        }

        /**
         * @param skipToken $skipToken is supported on list of product families, which provides the next page in the list of product families.
         * 
         * @return builder
         * 
         */
        public Builder skipToken(@Nullable Output<String> skipToken) {
            $.skipToken = skipToken;
            return this;
        }

        /**
         * @param skipToken $skipToken is supported on list of product families, which provides the next page in the list of product families.
         * 
         * @return builder
         * 
         */
        public Builder skipToken(String skipToken) {
            return skipToken(Output.of(skipToken));
        }

        public ListProductFamiliesArgs build() {
            $.filterableProperties = Objects.requireNonNull($.filterableProperties, "expected parameter 'filterableProperties' to be non-null");
            return $;
        }
    }

}
