package com.pulumi.core.annotations;

import java.lang.annotation.ElementType;
import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;
import java.lang.annotation.Target;

/**
 * Annotation used by a Pulumi Cloud Provider Package
 * to mark @see {@link com.pulumi.resources.Resource} input fields.
 * <p>
 * Note: this should just be placed on the field itself, not a setter or getter
 */
@Retention(RetentionPolicy.RUNTIME)
@Target(ElementType.FIELD)
public @interface Import {
    String name() default "";

    boolean required() default false;

    boolean json() default false;
}
